% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/funcharts-package.R
\docType{package}
\name{funcharts-package}
\alias{funcharts}
\alias{funcharts-package}
\title{funcharts: Functional Control Charts}
\description{
Provides functional control charts for statistical process monitoring of functional data, using the methods of Capezza et al. (2020) \doi{10.1002/asmb.2507}, Centofanti et al. (2021) \doi{10.1080/00401706.2020.1753581}, Capezza et al. (2024) \doi{10.1080/00401706.2024.2327346}, Capezza et al. (2024) \doi{10.1080/00224065.2024.2383674}, Centofanti et al. (2022) \href{https://arxiv.org/abs/2205.06256}{arXiv:2205.06256}. The package is thoroughly illustrated in the paper of Capezza et al (2023) \doi{10.1080/00224065.2023.2219012}.
}
\references{
Capezza C, Lepore A, Menafoglio A, Palumbo B, Vantini S. (2020)
Control charts for
monitoring ship operating conditions and CO2 emissions based
on scalar-on-function regression.
\emph{Applied Stochastic Models in Business and Industry},
36(3):477--500.
\url{doi:10.1002/asmb.2507}

Centofanti F, Lepore A, Menafoglio A, Palumbo B, Vantini S. (2021)
Functional Regression Control Chart.
\emph{Technometrics}, 63(3), 281--294. \url{doi:10.1080/00401706.2020.1753581}

Capezza, C., Centofanti, F., Lepore, A., Palumbo, B. (2024)
Robust Multivariate Functional Control Charts.
\emph{Technometrics}, \url{doi:10.1080/00401706.2024.2327346}.

Capezza, C., Capizzi, G., Centofanti, F., Lepore, A., Palumbo, B. (2024)
An Adaptive Multivariate Functional EWMA Control Chart.
To appear in \emph{Journal of Quality Technology}, \url{doi:10.1080/00224065.2024.2383674}.

Centofanti, F., A. Lepore, M. Kulahci, and M. P. Spooner (2024).
Real-time monitoring of functional data.
Accepted for publication in \emph{Journal of Quality Technology}.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/unina-sfere/funcharts}
  \item Report bugs at \url{https://github.com/unina-sfere/funcharts/issues}
}

}
\author{
\strong{Maintainer}: Christian Capezza \email{christian.capezza@unina.it}

Authors:
\itemize{
  \item Fabio Centofanti
  \item Antonio Lepore
  \item Biagio Palumbo
}

Other contributors:
\itemize{
  \item Alessandra Menafoglio [contributor]
  \item Simone Vantini [contributor]
}

}
\keyword{internal}
